<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/ASG.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/ASG.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/ASG.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;Abstract Syntax Tree classes.</span></span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-string"/></span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-string">This file contains classes which encapsulate nodes in the ASG. The base class</span></span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-string">is the Declaration class that encapsulates a named declaration. All names used</span></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-string">are scoped tuples.</span></span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-string"/></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-string">Also defined in module scope are the constants DEFAULT, PUBLIC, PROTECTED and</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-string">PRIVATE.</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-comment"># Accessibility constants</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">DEFAULT = 0</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">PUBLIC = 1</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">PROTECTED = 2</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">PRIVATE = 3</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG.html#ccmp">ccmp</a>(a,b):</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Compares classes of two objects&quot;&quot;&quot;</span></span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    <span class="py-keyword">return</span> cmp(type(a),type(b)) <span class="py-keyword">or</span> cmp(a.__class__,b.__class__)</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Error.html">Error</a>:</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Exception class used by ASG internals.&quot;&quot;&quot;</span></span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Error.html#__init__">__init__</a>(self, err):</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">      self.err = err</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Error.html#__repr__">__repr__</a>(self):</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">      <span class="py-keyword">return</span> self.err</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Debugger.html">Debugger</a>(type):</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Wrap the object's 'accept' method, printing out the visitor's type.</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-string">    Useful for tracing visitors visiting declarations.&quot;&quot;&quot;</span></span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Debugger.html#__init__">__init__</a>(cls, name, bases, dict):</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        accept = dict[<span class="py-string">'accept'</span>]</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">        <span class="py-string">&quot;The original instancemethod.&quot;</span></span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        <span class="py-keyword">def</span> accept_wrapper(self, visitor):</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">            <span class="py-string">&quot;The wrapper. The original 'accept' method is part of its closure.&quot;</span></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">            <span class="py-keyword">print</span> <span class="py-string">'%s accepting %s.%s'</span>%(self.__class__.__name__,</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">                                        visitor.__module__,</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">                                        visitor.__class__.__name__)</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">            accept(self, visitor)</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        setattr(cls, <span class="py-string">'accept'</span>, accept_wrapper)</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/TypeId.html">TypeId</a>(object):</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Type-id abstract class.&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TypeId.html#__init__">__init__</a>(self, language):</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        self.language = language</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TypeId.html#accept">accept</a>(self, visitor):</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        <span class="py-string">&quot;&quot;&quot;visitor pattern accept. @see Visitor&quot;&quot;&quot;</span></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        <span class="py-keyword">pass</span></span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        <span class="py-keyword">return</span> cmp(id(self),id(other))</span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/NamedTypeId.html">NamedTypeId</a>(TypeId):</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Named type abstract class&quot;&quot;&quot;</span></span>
<a id="line74"></a><span class="lineno"> 74</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/NamedTypeId.html#__init__">__init__</a>(self, language, name):</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">        super(NamedTypeId, self).__init__(language)</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        self.name = name</span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/BuiltinTypeId.html">BuiltinTypeId</a>(NamedTypeId):</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for builtin type-ids&quot;&quot;&quot;</span></span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/BuiltinTypeId.html#__init__">__init__</a>(self, language, name):</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        super(BuiltinTypeId, self).__init__(language, name)</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/BuiltinTypeId.html#accept">accept</a>(self, visitor): visitor.visit_builtin_type_id(self)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/BuiltinTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.name,other.name)</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/BuiltinTypeId.html#__str__">__str__</a>(self): <span class="py-keyword">return</span> str(self.name)</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/DependentTypeId.html">DependentTypeId</a>(NamedTypeId):</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for template dependent type-ids&quot;&quot;&quot;</span></span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DependentTypeId.html#__init__">__init__</a>(self, language, name):</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        super(DependentTypeId, self).__init__(language, name)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DependentTypeId.html#accept">accept</a>(self, visitor): visitor.visit_dependent_type_id(self)</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DependentTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.name,other.name)</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DependentTypeId.html#__str__">__str__</a>(self): <span class="py-keyword">return</span> str(self.name)</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/UnknownTypeId.html">UnknownTypeId</a>(NamedTypeId):</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for not (yet) known type-ids.&quot;&quot;&quot;</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line">    base = TypeId</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UnknownTypeId.html#__init__">__init__</a>(self, language, name):</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">        super(UnknownTypeId, self).__init__(language, name)</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        self.link = name</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UnknownTypeId.html#resolve">resolve</a>(self, language, name, link):</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Associate this type-id with an external reference, instead of a declaration.&quot;&quot;&quot;</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line">        self.base.language = language</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">        self.name = name</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        self.link = link</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UnknownTypeId.html#accept">accept</a>(self, visitor): visitor.visit_unknown_type_id(self)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UnknownTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.name,other.name)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UnknownTypeId.html#__str__">__str__</a>(self): <span class="py-keyword">return</span> str(self.name)</span>
<a id="line117"></a><span class="lineno">117</span>
<a id="line118"></a><span class="lineno">118</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/DeclaredTypeId.html">DeclaredTypeId</a>(NamedTypeId):</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for declared types&quot;&quot;&quot;</span></span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DeclaredTypeId.html#__init__">__init__</a>(self, language, name, declaration):</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        super(DeclaredTypeId, self).__init__(language, name)</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        self.declaration = declaration</span>
<a id="line124"></a><span class="lineno">124</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DeclaredTypeId.html#accept">accept</a>(self, visitor): visitor.visit_declared_type_id(self)</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DeclaredTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.name,other.name)</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/DeclaredTypeId.html#__str__">__str__</a>(self): <span class="py-keyword">return</span> str(self.name)</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/TemplateId.html">TemplateId</a>(DeclaredTypeId):</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for template-ids.&quot;&quot;&quot;</span></span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TemplateId.html#__init__">__init__</a>(self, language, name, declaration, parameters):</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        super(TemplateId, self).__init__(language, name, declaration)</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        self.parameters = parameters</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TemplateId.html#accept">accept</a>(self, visitor): visitor.visit_template_id(self)</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TemplateId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.parameters,other.parameters)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/TemplateId.html#__str__">__str__</a>(self):</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">&quot;template&lt;%s&gt;%s&quot;</span>%(<span class="py-string">','</span>.join([str(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> self.parameters]), str(self.name))</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/ModifierTypeId.html">ModifierTypeId</a>(TypeId):</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for alias types with modifiers (such as 'const', '&amp;', etc.)&quot;&quot;&quot;</span></span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ModifierTypeId.html#__init__">__init__</a>(self, language, alias, premod, postmod):</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">        super(ModifierTypeId, self).__init__(language)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">        self.alias = alias</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        self.premod = premod</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        self.postmod = postmod</span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ModifierTypeId.html#accept">accept</a>(self, visitor): visitor.visit_modifier_type_id(self)</span>
<a id="line155"></a><span class="lineno">155</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ModifierTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        <span class="py-keyword">return</span> (ccmp(self,other)</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">                <span class="py-keyword">or</span> cmp(self.alias,other.alias)</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">                <span class="py-keyword">or</span> cmp(self.premod,other.premod)</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">                <span class="py-keyword">or</span> cmp(self.postmod,other.postmod))</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ModifierTypeId.html#__str__">__str__</a>(self):</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">&quot;%s%s%s&quot;</span>%(<span class="py-string">''</span>.join([<span class="py-string">'%s '</span>%s <span class="py-keyword">for</span> s <span class="py-keyword">in</span> self.premod]),</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">                         str(self.alias),</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">                         <span class="py-string">''</span>.join(self.postmod))</span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/ArrayTypeId.html">ArrayTypeId</a>(TypeId):</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A modifier that adds array dimensions to a type-id.&quot;&quot;&quot;</span></span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ArrayTypeId.html#__init__">__init__</a>(self, language, alias, sizes):</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        super(ArrayId, self).__init__(language)</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        self.alias = alias</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">        self.sizes = sizes</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ArrayTypeId.html#accept">accept</a>(self, visitor): visitor.visit_array_type_id(self)</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ArrayTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line">        <span class="py-keyword">return</span> (ccmp(self,other)</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">                <span class="py-keyword">or</span> cmp(self.alias,other.alias)</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">                <span class="py-keyword">or</span> cmp(self.sizes,other.sizes))</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ArrayTypeId.html#__str__">__str__</a>(self):</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">&quot;%s%s&quot;</span>%(str(self.alias),</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">                       <span class="py-string">''</span>.join([<span class="py-string">'[%d]'</span>%s <span class="py-keyword">for</span> s <span class="py-keyword">in</span> self.sizes]))</span>
<a id="line183"></a><span class="lineno">183</span>
<a id="line184"></a><span class="lineno">184</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/ParametrizedTypeId.html">ParametrizedTypeId</a>(TypeId):</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for parametrized type-id instances.&quot;&quot;&quot;</span></span>
<a id="line186"></a><span class="lineno">186</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ParametrizedTypeId.html#__init__">__init__</a>(self, language, template, parameters):</span>
<a id="line188"></a><span class="lineno">188</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">        super(ParametrizedTypeId, self).__init__(language)</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">        self.template = template</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">        self.parameters = parameters</span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ParametrizedTypeId.html#accept">accept</a>(self, visitor): visitor.visit_parametrized_type_id(self)</span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ParametrizedTypeId.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line197"></a><span class="lineno">197</span><span class="line">        <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.template,other.template)</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ParametrizedTypeId.html#__str__">__str__</a>(self):</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">&quot;%s&lt;%s&gt;&quot;</span>%(<span class="py-string">'::'</span>.join(self.template.name),</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">                         <span class="py-string">','</span>.join([str(a) <span class="py-keyword">for</span> a <span class="py-keyword">in</span> self.parameters]))</span>
<a id="line201"></a><span class="lineno">201</span>
<a id="line202"></a><span class="lineno">202</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/FunctionTypeId.html">FunctionTypeId</a>(TypeId):</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Class for function (pointer) types.&quot;&quot;&quot;</span></span>
<a id="line204"></a><span class="lineno">204</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/FunctionTypeId.html#__init__">__init__</a>(self, language, return_type, premod, parameters):</span>
<a id="line205"></a><span class="lineno">205</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">        super(FunctionTypeId, self).__init__(language)</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">        self.return_type = return_type</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        self.premod = premod</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">        self.parameters = parameters</span>
<a id="line210"></a><span class="lineno">210</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/FunctionTypeId.html#accept">accept</a>(self, visitor): visitor.visit_function_type_id(self)</span>
<a id="line212"></a><span class="lineno">212</span>
<a id="line213"></a><span class="lineno">213</span>
<a id="line214"></a><span class="lineno">214</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Dictionary.html">Dictionary</a>(dict):</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Dictionary extends the builtin 'dict' by adding a lookup method to it.&quot;&quot;&quot;</span></span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Dictionary.html#lookup">lookup</a>(self, name, scopes):</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        <span class="py-string">&quot;&quot;&quot;locate 'name' in one of the scopes&quot;&quot;&quot;</span></span>
<a id="line219"></a><span class="lineno">219</span><span class="line">        <span class="py-keyword">for</span> s <span class="py-keyword">in</span> scopes:</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">            scope = list(s)</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">            <span class="py-keyword">while</span> len(scope) &gt; 0:</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">                <span class="py-keyword">if</span> self.has_key(scope + name):</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">                    <span class="py-keyword">return</span> self[scope + name]</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">                <span class="py-keyword">else</span>: <span class="py-keyword">del</span> scope[-1]</span>
<a id="line225"></a><span class="lineno">225</span><span class="line">        <span class="py-keyword">if</span> self.has_key(name):</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">            <span class="py-keyword">return</span> self[name]</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">        <span class="py-keyword">return</span> None</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Dictionary.html#merge">merge</a>(self, dict):</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">        <span class="py-string">&quot;&quot;&quot;merge in a foreign dictionary, overriding already defined types only</span></span>
<a id="line231"></a><span class="lineno">231</span><span class="line"><span class="py-string">        if they are of type 'Unknown'.&quot;&quot;&quot;</span></span>
<a id="line232"></a><span class="lineno">232</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> dict.keys():</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">            <span class="py-keyword">if</span> self.has_key(i):</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">                <span class="py-keyword">if</span> isinstance(self[i], UnknownTypeId):</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">                    self[i] = dict[i]</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">                    <span class="py-keyword">pass</span></span>
<a id="line238"></a><span class="lineno">238</span><span class="line">            <span class="py-keyword">else</span>: self[i] = dict[i]</span>
<a id="line239"></a><span class="lineno">239</span>
<a id="line240"></a><span class="lineno">240</span>
<a id="line241"></a><span class="lineno">241</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Declaration.html">Declaration</a>(object):</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Declaration base class. Every declaration has a name, type,</span></span>
<a id="line243"></a><span class="lineno">243</span><span class="line"><span class="py-string">    accessibility and annotations. The default accessibility is DEFAULT except for</span></span>
<a id="line244"></a><span class="lineno">244</span><span class="line"><span class="py-string">    C++ where the Parser always sets it to one of the other three. &quot;&quot;&quot;</span></span>
<a id="line245"></a><span class="lineno">245</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">    <span class="py-comment">#__metaclass__ = Debugger</span></span>
<a id="line247"></a><span class="lineno">247</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Declaration.html#__init__">__init__</a>(self, file, line, type, name):</span>
<a id="line249"></a><span class="lineno">249</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">        self.file  = file</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">        <span class="py-string">&quot;&quot;&quot;SourceFile instance this declaration is part of.&quot;&quot;&quot;</span></span>
<a id="line252"></a><span class="lineno">252</span><span class="line">        self.line  = line</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The line number of this declaration.&quot;&quot;&quot;</span></span>
<a id="line254"></a><span class="lineno">254</span><span class="line">        self.name = name</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">        <span class="py-string">&quot;&quot;&quot;The (fully qualified) name of the declared object.&quot;&quot;&quot;</span></span>
<a id="line256"></a><span class="lineno">256</span><span class="line">        self.type = type</span>
<a id="line257"></a><span class="lineno">257</span><span class="line">        <span class="py-string">&quot;&quot;&quot;A string describing the (language-specific) type of the declared object.&quot;&quot;&quot;</span></span>
<a id="line258"></a><span class="lineno">258</span><span class="line">        self.accessibility = DEFAULT</span>
<a id="line259"></a><span class="lineno">259</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Accessibility descriptor for the declared object.&quot;&quot;&quot;</span></span>
<a id="line260"></a><span class="lineno">260</span><span class="line">        self.annotations = {}</span>
<a id="line261"></a><span class="lineno">261</span><span class="line">        <span class="py-string">&quot;&quot;&quot;A dictionary holding any annotations of this object.&quot;&quot;&quot;</span></span>
<a id="line262"></a><span class="lineno">262</span>
<a id="line263"></a><span class="lineno">263</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Declaration.html#accept">accept</a>(self, visitor):</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Visit the given visitor&quot;&quot;&quot;</span></span>
<a id="line265"></a><span class="lineno">265</span><span class="line">        visitor.visit_declaration(self)</span>
<a id="line266"></a><span class="lineno">266</span>
<a id="line267"></a><span class="lineno">267</span>
<a id="line268"></a><span class="lineno">268</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Builtin.html">Builtin</a>(Declaration):</span>
<a id="line269"></a><span class="lineno">269</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A node for internal use only.&quot;&quot;&quot;</span></span>
<a id="line270"></a><span class="lineno">270</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Builtin.html#accept">accept</a>(self, visitor): visitor.visit_builtin(self)</span>
<a id="line272"></a><span class="lineno">272</span>
<a id="line273"></a><span class="lineno">273</span>
<a id="line274"></a><span class="lineno">274</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/UsingDirective.html">UsingDirective</a>(Builtin):</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Import one module's content into another.&quot;&quot;&quot;</span></span>
<a id="line276"></a><span class="lineno">276</span>
<a id="line277"></a><span class="lineno">277</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UsingDirective.html#accept">accept</a>(self, visitor): visitor.visit_using_directive(self)</span>
<a id="line278"></a><span class="lineno">278</span>
<a id="line279"></a><span class="lineno">279</span>
<a id="line280"></a><span class="lineno">280</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/UsingDeclaration.html">UsingDeclaration</a>(Builtin):</span>
<a id="line281"></a><span class="lineno">281</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Import a declaration into this module.&quot;&quot;&quot;</span></span>
<a id="line282"></a><span class="lineno">282</span>
<a id="line283"></a><span class="lineno">283</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UsingDeclaration.html#__init__">__init__</a>(self, file, line, type, name, alias):</span>
<a id="line284"></a><span class="lineno">284</span>
<a id="line285"></a><span class="lineno">285</span><span class="line">        super(UsingDeclaration, self).__init__(file, line, type, name)</span>
<a id="line286"></a><span class="lineno">286</span><span class="line">        self.alias = alias</span>
<a id="line287"></a><span class="lineno">287</span>
<a id="line288"></a><span class="lineno">288</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/UsingDeclaration.html#accept">accept</a>(self, visitor):</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">        visitor.visit_using_declaration(self)</span>
<a id="line290"></a><span class="lineno">290</span>
<a id="line291"></a><span class="lineno">291</span>
<a id="line292"></a><span class="lineno">292</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Macro.html">Macro</a>(Declaration):</span>
<a id="line293"></a><span class="lineno">293</span><span class="line">   <span class="py-string">&quot;&quot;&quot;A preprocessor macro. Note that macros are not strictly part of the</span></span>
<a id="line294"></a><span class="lineno">294</span><span class="line"><span class="py-string">   ASG, and as such are always in the global scope. A macro is &quot;temporary&quot; if</span></span>
<a id="line295"></a><span class="lineno">295</span><span class="line"><span class="py-string">   it was #undefined in the same file it was #defined in.&quot;&quot;&quot;</span></span>
<a id="line296"></a><span class="lineno">296</span>
<a id="line297"></a><span class="lineno">297</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Macro.html#__init__">__init__</a>(self, file, line, type, name, parameters, text):</span>
<a id="line298"></a><span class="lineno">298</span>
<a id="line299"></a><span class="lineno">299</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line300"></a><span class="lineno">300</span><span class="line">      self.parameters = parameters</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">      self.text = text</span>
<a id="line302"></a><span class="lineno">302</span>
<a id="line303"></a><span class="lineno">303</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Macro.html#accept">accept</a>(self, visitor): visitor.visit_macro(self)</span>
<a id="line304"></a><span class="lineno">304</span>
<a id="line305"></a><span class="lineno">305</span>
<a id="line306"></a><span class="lineno">306</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Forward.html">Forward</a>(Declaration):</span>
<a id="line307"></a><span class="lineno">307</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Forward declaration&quot;&quot;&quot;</span></span>
<a id="line308"></a><span class="lineno">308</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Forward.html#__init__">__init__</a>(self, file, line, type, name, is_template_specialization = False):</span>
<a id="line310"></a><span class="lineno">310</span>
<a id="line311"></a><span class="lineno">311</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line312"></a><span class="lineno">312</span><span class="line">      self.template = None</span>
<a id="line313"></a><span class="lineno">313</span><span class="line">      self.is_template_specialization = is_template_specialization</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">      self.primary_template = None</span>
<a id="line315"></a><span class="lineno">315</span><span class="line">      self.specializations = []</span>
<a id="line316"></a><span class="lineno">316</span>
<a id="line317"></a><span class="lineno">317</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Forward.html#accept">accept</a>(self, visitor):</span>
<a id="line318"></a><span class="lineno">318</span>
<a id="line319"></a><span class="lineno">319</span><span class="line">       visitor.visit_forward(self)</span>
<a id="line320"></a><span class="lineno">320</span>
<a id="line321"></a><span class="lineno">321</span>
<a id="line322"></a><span class="lineno">322</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Group.html">Group</a>(Declaration):</span>
<a id="line323"></a><span class="lineno">323</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Base class for groups which contain declarations.</span></span>
<a id="line324"></a><span class="lineno">324</span><span class="line"><span class="py-string">   This class doesn't correspond to any language construct.</span></span>
<a id="line325"></a><span class="lineno">325</span><span class="line"><span class="py-string">   Rather, it may be used with comment-embedded grouping tags</span></span>
<a id="line326"></a><span class="lineno">326</span><span class="line"><span class="py-string">   to regroup declarations that are to appear together in the</span></span>
<a id="line327"></a><span class="lineno">327</span><span class="line"><span class="py-string">   manual.&quot;&quot;&quot;</span></span>
<a id="line328"></a><span class="lineno">328</span>
<a id="line329"></a><span class="lineno">329</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Group.html#__init__">__init__</a>(self, file, line, type, name):</span>
<a id="line330"></a><span class="lineno">330</span>
<a id="line331"></a><span class="lineno">331</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line332"></a><span class="lineno">332</span><span class="line">      self.declarations = []</span>
<a id="line333"></a><span class="lineno">333</span>
<a id="line334"></a><span class="lineno">334</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Group.html#accept">accept</a>(self, visitor):</span>
<a id="line335"></a><span class="lineno">335</span>
<a id="line336"></a><span class="lineno">336</span><span class="line">      visitor.visit_group(self)</span>
<a id="line337"></a><span class="lineno">337</span>
<a id="line338"></a><span class="lineno">338</span>
<a id="line339"></a><span class="lineno">339</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Scope.html">Scope</a>(Declaration):</span>
<a id="line340"></a><span class="lineno">340</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Base class for scopes (named groups).&quot;&quot;&quot;</span></span>
<a id="line341"></a><span class="lineno">341</span>
<a id="line342"></a><span class="lineno">342</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Scope.html#__init__">__init__</a>(self, file, line, type, name):</span>
<a id="line343"></a><span class="lineno">343</span>
<a id="line344"></a><span class="lineno">344</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line345"></a><span class="lineno">345</span><span class="line">      self.declarations = []</span>
<a id="line346"></a><span class="lineno">346</span>
<a id="line347"></a><span class="lineno">347</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Scope.html#accept">accept</a>(self, visitor): visitor.visit_scope(self)</span>
<a id="line348"></a><span class="lineno">348</span>
<a id="line349"></a><span class="lineno">349</span>
<a id="line350"></a><span class="lineno">350</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Module.html">Module</a>(Scope):</span>
<a id="line351"></a><span class="lineno">351</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Module class&quot;&quot;&quot;</span></span>
<a id="line352"></a><span class="lineno">352</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Module.html#__init__">__init__</a>(self, file, line, type, name):</span>
<a id="line353"></a><span class="lineno">353</span>
<a id="line354"></a><span class="lineno">354</span><span class="line">      Scope.__init__(self, file, line, type, name)</span>
<a id="line355"></a><span class="lineno">355</span>
<a id="line356"></a><span class="lineno">356</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Module.html#accept">accept</a>(self, visitor): visitor.visit_module(self)</span>
<a id="line357"></a><span class="lineno">357</span>
<a id="line358"></a><span class="lineno">358</span>
<a id="line359"></a><span class="lineno">359</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/MetaModule.html">MetaModule</a>(Module):</span>
<a id="line360"></a><span class="lineno">360</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Module Class that references all places where this Module occurs&quot;&quot;&quot;</span></span>
<a id="line361"></a><span class="lineno">361</span>
<a id="line362"></a><span class="lineno">362</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/MetaModule.html#__init__">__init__</a>(self, type, name):</span>
<a id="line363"></a><span class="lineno">363</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">      Scope.__init__(self, None, <span class="py-string">&quot;&quot;</span>, type, name)</span>
<a id="line365"></a><span class="lineno">365</span><span class="line">      self.module_declarations = []</span>
<a id="line366"></a><span class="lineno">366</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/MetaModule.html#accept">accept</a>(self, visitor): visitor.visit_meta_module(self)</span>
<a id="line368"></a><span class="lineno">368</span>
<a id="line369"></a><span class="lineno">369</span>
<a id="line370"></a><span class="lineno">370</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Inheritance.html">Inheritance</a>(object):</span>
<a id="line371"></a><span class="lineno">371</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Inheritance class. This class encapsulates the information about an</span></span>
<a id="line372"></a><span class="lineno">372</span><span class="line"><span class="py-string">   inheritance, such as attributes like 'virtual' and 'public' &quot;&quot;&quot;</span></span>
<a id="line373"></a><span class="lineno">373</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Inheritance.html#__init__">__init__</a>(self, type, parent, attributes):</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">      self.type = type</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">      self.parent = parent</span>
<a id="line377"></a><span class="lineno">377</span><span class="line">      self.attributes = attributes</span>
<a id="line378"></a><span class="lineno">378</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Inheritance.html#accept">accept</a>(self, visitor): visitor.visit_inheritance(self)</span>
<a id="line380"></a><span class="lineno">380</span>
<a id="line381"></a><span class="lineno">381</span>
<a id="line382"></a><span class="lineno">382</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Class.html">Class</a>(Scope):</span>
<a id="line383"></a><span class="lineno">383</span>
<a id="line384"></a><span class="lineno">384</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Class.html#__init__">__init__</a>(self, file, line, type, name, is_template_specialization = False):</span>
<a id="line385"></a><span class="lineno">385</span>
<a id="line386"></a><span class="lineno">386</span><span class="line">      Scope.__init__(self, file, line, type, name)</span>
<a id="line387"></a><span class="lineno">387</span><span class="line">      self.parents = []</span>
<a id="line388"></a><span class="lineno">388</span><span class="line">      self.is_template_specialization = is_template_specialization</span>
<a id="line389"></a><span class="lineno">389</span><span class="line">      self.primary_template = None</span>
<a id="line390"></a><span class="lineno">390</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Class.html#accept">accept</a>(self, visitor): visitor.visit_class(self)</span>
<a id="line392"></a><span class="lineno">392</span>
<a id="line393"></a><span class="lineno">393</span>
<a id="line394"></a><span class="lineno">394</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/ClassTemplate.html">ClassTemplate</a>(Scope):</span>
<a id="line395"></a><span class="lineno">395</span>
<a id="line396"></a><span class="lineno">396</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ClassTemplate.html#__init__">__init__</a>(self, file, line, type, name,</span>
<a id="line397"></a><span class="lineno">397</span><span class="line">                template = None, is_template_specialization = False):</span>
<a id="line398"></a><span class="lineno">398</span>
<a id="line399"></a><span class="lineno">399</span><span class="line">      Scope.__init__(self, file, line, type, name)</span>
<a id="line400"></a><span class="lineno">400</span><span class="line">      self.parents = []</span>
<a id="line401"></a><span class="lineno">401</span><span class="line">      self.template = template</span>
<a id="line402"></a><span class="lineno">402</span><span class="line">      self.is_template_specialization = is_template_specialization</span>
<a id="line403"></a><span class="lineno">403</span><span class="line">      self.primary_template = None</span>
<a id="line404"></a><span class="lineno">404</span><span class="line">      self.specializations = []</span>
<a id="line405"></a><span class="lineno">405</span>
<a id="line406"></a><span class="lineno">406</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ClassTemplate.html#accept">accept</a>(self, visitor): visitor.visit_class_template(self)</span>
<a id="line407"></a><span class="lineno">407</span>
<a id="line408"></a><span class="lineno">408</span>
<a id="line409"></a><span class="lineno">409</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Typedef.html">Typedef</a>(Declaration):</span>
<a id="line410"></a><span class="lineno">410</span>
<a id="line411"></a><span class="lineno">411</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Typedef.html#__init__">__init__</a>(self, file, line, type, name, alias, constr):</span>
<a id="line412"></a><span class="lineno">412</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line413"></a><span class="lineno">413</span><span class="line">      self.alias = alias</span>
<a id="line414"></a><span class="lineno">414</span><span class="line">      self.constr = constr</span>
<a id="line415"></a><span class="lineno">415</span>
<a id="line416"></a><span class="lineno">416</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Typedef.html#accept">accept</a>(self, visitor): visitor.visit_typedef(self)</span>
<a id="line417"></a><span class="lineno">417</span>
<a id="line418"></a><span class="lineno">418</span>
<a id="line419"></a><span class="lineno">419</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Enumerator.html">Enumerator</a>(Declaration):</span>
<a id="line420"></a><span class="lineno">420</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Enumerator of an Enum. Enumerators represent the individual names and</span></span>
<a id="line421"></a><span class="lineno">421</span><span class="line"><span class="py-string">   values in an enum.&quot;&quot;&quot;</span></span>
<a id="line422"></a><span class="lineno">422</span>
<a id="line423"></a><span class="lineno">423</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Enumerator.html#__init__">__init__</a>(self, file, line, name, value):</span>
<a id="line424"></a><span class="lineno">424</span><span class="line">      Declaration.__init__(self, file, line, <span class="py-string">&quot;enumerator&quot;</span>, name)</span>
<a id="line425"></a><span class="lineno">425</span><span class="line">      self.value = value</span>
<a id="line426"></a><span class="lineno">426</span>
<a id="line427"></a><span class="lineno">427</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Enumerator.html#accept">accept</a>(self, visitor): visitor.visit_enumerator(self)</span>
<a id="line428"></a><span class="lineno">428</span>
<a id="line429"></a><span class="lineno">429</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Enum.html">Enum</a>(Declaration):</span>
<a id="line430"></a><span class="lineno">430</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Enum declaration. The actual names and values are encapsulated by</span></span>
<a id="line431"></a><span class="lineno">431</span><span class="line"><span class="py-string">   Enumerator objects.&quot;&quot;&quot;</span></span>
<a id="line432"></a><span class="lineno">432</span>
<a id="line433"></a><span class="lineno">433</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Enum.html#__init__">__init__</a>(self, file, line, name, enumerators):</span>
<a id="line434"></a><span class="lineno">434</span>
<a id="line435"></a><span class="lineno">435</span><span class="line">      Declaration.__init__(self, file, line, <span class="py-string">&quot;enum&quot;</span>, name)</span>
<a id="line436"></a><span class="lineno">436</span><span class="line">      self.enumerators = enumerators[:]</span>
<a id="line437"></a><span class="lineno">437</span><span class="line">      <span class="py-comment">#FIXME: the Cxx parser will append a Builtin('eos') to the</span></span>
<a id="line438"></a><span class="lineno">438</span><span class="line">      <span class="py-comment">#list of enumerators which we need to extract here.</span></span>
<a id="line439"></a><span class="lineno">439</span><span class="line">      self.eos = None</span>
<a id="line440"></a><span class="lineno">440</span><span class="line">      <span class="py-keyword">if</span> self.enumerators <span class="py-keyword">and</span> isinstance(self.enumerators[-1], Builtin):</span>
<a id="line441"></a><span class="lineno">441</span><span class="line">         self.eos = self.enumerators.pop()</span>
<a id="line442"></a><span class="lineno">442</span>
<a id="line443"></a><span class="lineno">443</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Enum.html#accept">accept</a>(self, visitor): visitor.visit_enum(self)</span>
<a id="line444"></a><span class="lineno">444</span>
<a id="line445"></a><span class="lineno">445</span>
<a id="line446"></a><span class="lineno">446</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Variable.html">Variable</a>(Declaration):</span>
<a id="line447"></a><span class="lineno">447</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Variable definition&quot;&quot;&quot;</span></span>
<a id="line448"></a><span class="lineno">448</span>
<a id="line449"></a><span class="lineno">449</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Variable.html#__init__">__init__</a>(self, file, line, type, name, vtype, constr):</span>
<a id="line450"></a><span class="lineno">450</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line451"></a><span class="lineno">451</span><span class="line">      self.vtype  = vtype</span>
<a id="line452"></a><span class="lineno">452</span><span class="line">      self.constr  = constr</span>
<a id="line453"></a><span class="lineno">453</span>
<a id="line454"></a><span class="lineno">454</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Variable.html#accept">accept</a>(self, visitor): visitor.visit_variable(self)</span>
<a id="line455"></a><span class="lineno">455</span>
<a id="line456"></a><span class="lineno">456</span>
<a id="line457"></a><span class="lineno">457</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Const.html">Const</a>(Declaration):</span>
<a id="line458"></a><span class="lineno">458</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Constant declaration. A constant is a name with a type and value.&quot;&quot;&quot;</span></span>
<a id="line459"></a><span class="lineno">459</span>
<a id="line460"></a><span class="lineno">460</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Const.html#__init__">__init__</a>(self, file, line, type, ctype, name, value):</span>
<a id="line461"></a><span class="lineno">461</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line462"></a><span class="lineno">462</span><span class="line">      self.ctype  = ctype</span>
<a id="line463"></a><span class="lineno">463</span><span class="line">      self.value = value</span>
<a id="line464"></a><span class="lineno">464</span>
<a id="line465"></a><span class="lineno">465</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Const.html#accept">accept</a>(self, visitor): visitor.visit_const(self)</span>
<a id="line466"></a><span class="lineno">466</span>
<a id="line467"></a><span class="lineno">467</span>
<a id="line468"></a><span class="lineno">468</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Parameter.html">Parameter</a>(object):</span>
<a id="line469"></a><span class="lineno">469</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Function Parameter&quot;&quot;&quot;</span></span>
<a id="line470"></a><span class="lineno">470</span>
<a id="line471"></a><span class="lineno">471</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Parameter.html#__init__">__init__</a>(self, premod, type, postmod, name=<span class="py-string">''</span>, value=<span class="py-string">''</span>):</span>
<a id="line472"></a><span class="lineno">472</span><span class="line">      self.premodifier = premod</span>
<a id="line473"></a><span class="lineno">473</span><span class="line">      self.type = type</span>
<a id="line474"></a><span class="lineno">474</span><span class="line">      self.postmodifier = postmod</span>
<a id="line475"></a><span class="lineno">475</span><span class="line">      self.name = name</span>
<a id="line476"></a><span class="lineno">476</span><span class="line">      self.value = value</span>
<a id="line477"></a><span class="lineno">477</span>
<a id="line478"></a><span class="lineno">478</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Parameter.html#accept">accept</a>(self, visitor): visitor.visit_parameter(self)</span>
<a id="line479"></a><span class="lineno">479</span>
<a id="line480"></a><span class="lineno">480</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Parameter.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line481"></a><span class="lineno">481</span><span class="line">      <span class="py-string">&quot;Comparison operator&quot;</span></span>
<a id="line482"></a><span class="lineno">482</span><span class="line">      <span class="py-comment">#print &quot;Parameter.__cmp__&quot;</span></span>
<a id="line483"></a><span class="lineno">483</span><span class="line">      <span class="py-keyword">return</span> cmp(self.type,other.type)</span>
<a id="line484"></a><span class="lineno">484</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Parameter.html#__str__">__str__</a>(self):</span>
<a id="line485"></a><span class="lineno">485</span><span class="line">      <span class="py-keyword">return</span> <span class="py-string">&quot;%s%s%s&quot;</span>%(<span class="py-string">' '</span>.join(self.premodifier),</span>
<a id="line486"></a><span class="lineno">486</span><span class="line">                       str(self.type),</span>
<a id="line487"></a><span class="lineno">487</span><span class="line">                       <span class="py-string">' '</span>.join(self.postmodifier))</span>
<a id="line488"></a><span class="lineno">488</span>
<a id="line489"></a><span class="lineno">489</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Function.html">Function</a>(Declaration):</span>
<a id="line490"></a><span class="lineno">490</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Function declaration.</span></span>
<a id="line491"></a><span class="lineno">491</span><span class="line"><span class="py-string">   Note that function names are stored in mangled form to allow overriding.</span></span>
<a id="line492"></a><span class="lineno">492</span><span class="line"><span class="py-string">   Formatters should use the real_name to extract the unmangled name.&quot;&quot;&quot;</span></span>
<a id="line493"></a><span class="lineno">493</span>
<a id="line494"></a><span class="lineno">494</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Function.html#__init__">__init__</a>(self, file, line, type, premod, return_type, postmod, name, real_name):</span>
<a id="line495"></a><span class="lineno">495</span><span class="line">      Declaration.__init__(self, file, line, type, name)</span>
<a id="line496"></a><span class="lineno">496</span><span class="line">      self._real_name = real_name</span>
<a id="line497"></a><span class="lineno">497</span><span class="line">      self.premodifier = premod</span>
<a id="line498"></a><span class="lineno">498</span><span class="line">      self.return_type = return_type</span>
<a id="line499"></a><span class="lineno">499</span><span class="line">      self.parameters = []</span>
<a id="line500"></a><span class="lineno">500</span><span class="line">      self.postmodifier = postmod</span>
<a id="line501"></a><span class="lineno">501</span><span class="line">      self.exceptions = []</span>
<a id="line502"></a><span class="lineno">502</span>
<a id="line503"></a><span class="lineno">503</span><span class="line">   real_name = property(<span class="py-keyword">lambda</span> self: self.name[:-1] + (self._real_name,))</span>
<a id="line504"></a><span class="lineno">504</span>
<a id="line505"></a><span class="lineno">505</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Function.html#accept">accept</a>(self, visitor): visitor.visit_function(self)</span>
<a id="line506"></a><span class="lineno">506</span>
<a id="line507"></a><span class="lineno">507</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Function.html#__cmp__">__cmp__</a>(self, other):</span>
<a id="line508"></a><span class="lineno">508</span><span class="line">      <span class="py-string">&quot;Recursively compares the typespec of the function&quot;</span></span>
<a id="line509"></a><span class="lineno">509</span><span class="line">      <span class="py-keyword">return</span> ccmp(self,other) <span class="py-keyword">or</span> cmp(self.parameters, other.parameters)</span>
<a id="line510"></a><span class="lineno">510</span>
<a id="line511"></a><span class="lineno">511</span>
<a id="line512"></a><span class="lineno">512</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/FunctionTemplate.html">FunctionTemplate</a>(Function):</span>
<a id="line513"></a><span class="lineno">513</span>
<a id="line514"></a><span class="lineno">514</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/FunctionTemplate.html#__init__">__init__</a>(self, file, line, type, premod, return_type, postmod, name, real_name, template = None):</span>
<a id="line515"></a><span class="lineno">515</span><span class="line">      Function.__init__(self, file, line, type, premod, return_type, postmod, name, real_name)</span>
<a id="line516"></a><span class="lineno">516</span><span class="line">      self.template = template</span>
<a id="line517"></a><span class="lineno">517</span>
<a id="line518"></a><span class="lineno">518</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/FunctionTemplate.html#accept">accept</a>(self, visitor): visitor.visit_function_template(self)</span>
<a id="line519"></a><span class="lineno">519</span>
<a id="line520"></a><span class="lineno">520</span>
<a id="line521"></a><span class="lineno">521</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Operation.html">Operation</a>(Function):</span>
<a id="line522"></a><span class="lineno">522</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Operation class. An operation is related to a Function and is currently</span></span>
<a id="line523"></a><span class="lineno">523</span><span class="line"><span class="py-string">   identical.</span></span>
<a id="line524"></a><span class="lineno">524</span><span class="line"><span class="py-string">   &quot;&quot;&quot;</span></span>
<a id="line525"></a><span class="lineno">525</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Operation.html#__init__">__init__</a>(self, file, line, type, premod, return_type, postmod, name, real_name):</span>
<a id="line526"></a><span class="lineno">526</span><span class="line">      Function.__init__(self, file, line, type, premod, return_type, postmod, name, real_name)</span>
<a id="line527"></a><span class="lineno">527</span>
<a id="line528"></a><span class="lineno">528</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Operation.html#accept">accept</a>(self, visitor): visitor.visit_operation(self)</span>
<a id="line529"></a><span class="lineno">529</span>
<a id="line530"></a><span class="lineno">530</span>
<a id="line531"></a><span class="lineno">531</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/OperationTemplate.html">OperationTemplate</a>(Operation):</span>
<a id="line532"></a><span class="lineno">532</span>
<a id="line533"></a><span class="lineno">533</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/OperationTemplate.html#__init__">__init__</a>(self, file, line, type, premod, return_type, postmod, name, real_name, template = None):</span>
<a id="line534"></a><span class="lineno">534</span><span class="line">      Operation.__init__(self, file, line, type, premod, return_type, postmod, name, real_name)</span>
<a id="line535"></a><span class="lineno">535</span><span class="line">      self.template = template</span>
<a id="line536"></a><span class="lineno">536</span>
<a id="line537"></a><span class="lineno">537</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/OperationTemplate.html#accept">accept</a>(self, visitor): visitor.visit_operation_template(self)</span>
<a id="line538"></a><span class="lineno">538</span>
<a id="line539"></a><span class="lineno">539</span>
<a id="line540"></a><span class="lineno">540</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html">Visitor</a>(object):</span>
<a id="line541"></a><span class="lineno">541</span><span class="line">   <span class="py-string">&quot;&quot;&quot;Visitor for ASG nodes&quot;&quot;&quot;</span></span>
<a id="line542"></a><span class="lineno">542</span>
<a id="line543"></a><span class="lineno">543</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line544"></a><span class="lineno">544</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line545"></a><span class="lineno">545</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_declared_type_id">visit_declared_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line546"></a><span class="lineno">546</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line547"></a><span class="lineno">547</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_array_type_id">visit_array_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line548"></a><span class="lineno">548</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_template_id">visit_template_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line549"></a><span class="lineno">549</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line550"></a><span class="lineno">550</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_function_type_id">visit_function_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line551"></a><span class="lineno">551</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_dependent_type_id">visit_dependent_type_id</a>(self, type): <span class="py-keyword">pass</span></span>
<a id="line552"></a><span class="lineno">552</span>
<a id="line553"></a><span class="lineno">553</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_declaration">visit_declaration</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line554"></a><span class="lineno">554</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_builtin">visit_builtin</a>(self, node):</span>
<a id="line555"></a><span class="lineno">555</span><span class="line">      <span class="py-string">&quot;&quot;&quot;Visit a Builtin instance. By default do nothing. Processors who</span></span>
<a id="line556"></a><span class="lineno">556</span><span class="line"><span class="py-string">      operate on Builtin nodes have to provide an appropriate implementation.&quot;&quot;&quot;</span></span>
<a id="line557"></a><span class="lineno">557</span><span class="line">      <span class="py-keyword">pass</span></span>
<a id="line558"></a><span class="lineno">558</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_using_directive">visit_using_directive</a>(self, node): self.visit_builtin(node)</span>
<a id="line559"></a><span class="lineno">559</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_using_declaration">visit_using_declaration</a>(self, node): self.visit_builtin(node)</span>
<a id="line560"></a><span class="lineno">560</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_macro">visit_macro</a>(self, node): self.visit_declaration(node)</span>
<a id="line561"></a><span class="lineno">561</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_forward">visit_forward</a>(self, node): self.visit_declaration(node)</span>
<a id="line562"></a><span class="lineno">562</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_group">visit_group</a>(self, node):</span>
<a id="line563"></a><span class="lineno">563</span><span class="line">      self.visit_declaration(node)</span>
<a id="line564"></a><span class="lineno">564</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations: d.accept(self)</span>
<a id="line565"></a><span class="lineno">565</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_scope">visit_scope</a>(self, node):</span>
<a id="line566"></a><span class="lineno">566</span><span class="line">      self.visit_declaration(node)</span>
<a id="line567"></a><span class="lineno">567</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations: d.accept(self)</span>
<a id="line568"></a><span class="lineno">568</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_module">visit_module</a>(self, node): self.visit_scope(node)</span>
<a id="line569"></a><span class="lineno">569</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_meta_module">visit_meta_module</a>(self, node): self.visit_module(node)</span>
<a id="line570"></a><span class="lineno">570</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_class">visit_class</a>(self, node): self.visit_scope(node)</span>
<a id="line571"></a><span class="lineno">571</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_class_template">visit_class_template</a>(self, node): self.visit_class(node)</span>
<a id="line572"></a><span class="lineno">572</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_typedef">visit_typedef</a>(self, node): self.visit_declaration(node)</span>
<a id="line573"></a><span class="lineno">573</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_enumerator">visit_enumerator</a>(self, node): self.visit_declaration(node)</span>
<a id="line574"></a><span class="lineno">574</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_enum">visit_enum</a>(self, node):</span>
<a id="line575"></a><span class="lineno">575</span><span class="line">      self.visit_declaration(node)</span>
<a id="line576"></a><span class="lineno">576</span><span class="line">      <span class="py-keyword">for</span> e <span class="py-keyword">in</span> node.enumerators:</span>
<a id="line577"></a><span class="lineno">577</span><span class="line">         e.accept(self)</span>
<a id="line578"></a><span class="lineno">578</span><span class="line">      <span class="py-keyword">if</span> node.eos:</span>
<a id="line579"></a><span class="lineno">579</span><span class="line">         node.eos.accept(self)</span>
<a id="line580"></a><span class="lineno">580</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_variable">visit_variable</a>(self, node): self.visit_declaration(node)</span>
<a id="line581"></a><span class="lineno">581</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_const">visit_const</a>(self, node): self.visit_declaration(node)</span>
<a id="line582"></a><span class="lineno">582</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_function">visit_function</a>(self, node):</span>
<a id="line583"></a><span class="lineno">583</span><span class="line">      self.visit_declaration(node)</span>
<a id="line584"></a><span class="lineno">584</span><span class="line">      <span class="py-keyword">for</span> parameter <span class="py-keyword">in</span> node.parameters: parameter.accept(self)</span>
<a id="line585"></a><span class="lineno">585</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_function_template">visit_function_template</a>(self, node): self.visit_function(node)</span>
<a id="line586"></a><span class="lineno">586</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_operation">visit_operation</a>(self, node): self.visit_function(node)</span>
<a id="line587"></a><span class="lineno">587</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_operation_template">visit_operation_template</a>(self, node): self.visit_operation(node)</span>
<a id="line588"></a><span class="lineno">588</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_parameter">visit_parameter</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line589"></a><span class="lineno">589</span><span class="line">   <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/Visitor.html#visit_inheritance">visit_inheritance</a>(self, node): <span class="py-keyword">pass</span></span>
<a id="line590"></a><span class="lineno">590</span>
<a id="line591"></a><span class="lineno">591</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/ASG/ASG.html">ASG</a>(object):</span>
<a id="line592"></a><span class="lineno">592</span>
<a id="line593"></a><span class="lineno">593</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ASG.html#__init__">__init__</a>(self, declarations = None, types = None):</span>
<a id="line594"></a><span class="lineno">594</span>
<a id="line595"></a><span class="lineno">595</span><span class="line">        self.declarations = declarations <span class="py-keyword">or</span> []</span>
<a id="line596"></a><span class="lineno">596</span><span class="line">        self.types = types <span class="py-keyword">or</span> Dictionary()</span>
<a id="line597"></a><span class="lineno">597</span>
<a id="line598"></a><span class="lineno">598</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ASG.html#copy">copy</a>(self):</span>
<a id="line599"></a><span class="lineno">599</span>
<a id="line600"></a><span class="lineno">600</span><span class="line">        <span class="py-keyword">return</span> type(self)(self.declarations[:],</span>
<a id="line601"></a><span class="lineno">601</span><span class="line">                          self.types.copy())</span>
<a id="line602"></a><span class="lineno">602</span>
<a id="line603"></a><span class="lineno">603</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/ASG/ASG.html#merge">merge</a>(self, other):</span>
<a id="line604"></a><span class="lineno">604</span>
<a id="line605"></a><span class="lineno">605</span><span class="line">        self.declarations.extend(other.declarations)</span>
<a id="line606"></a><span class="lineno">606</span><span class="line">        self.types.merge(other.types)</span>
<a id="line607"></a><span class="lineno">607</span>
<a id="line608"></a><span class="lineno">608</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
